package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.UserRoleDetail;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDetail_Grid_Main2{
    private String userobjectname;
    private String userobjectid;
    private String userroledetailid;
    private String uesrrolename;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    private String userroleid;
    public  void fromUserRoleDetail(UserRoleDetail sourceEntity)  {
         this.setUserobjectname(sourceEntity.getUserobjectname());
         this.setUserobjectid(sourceEntity.getUserobjectid());
         this.setUserroledetailid(sourceEntity.getUserroledetailid());
         this.setUesrrolename(sourceEntity.getUesrrolename());
         this.setSrfmajortext(sourceEntity.getUserroledetailname());
         this.setSrfdataaccaction(sourceEntity.getUserroledetailid());
         this.setSrfkey(sourceEntity.getUserroledetailid());
         this.setUserroleid(sourceEntity.getUserroleid());
	}

	public static Page<UserRoleDetail_Grid_Main2> fromUserRoleDetail(Page<UserRoleDetail> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<UserRoleDetail_Grid_Main2> targetpage=new Page<UserRoleDetail_Grid_Main2>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<UserRoleDetail_Grid_Main2> records=new ArrayList<UserRoleDetail_Grid_Main2>();
        for(UserRoleDetail source:sourcePage.getRecords()) {
            UserRoleDetail_Grid_Main2 target=new UserRoleDetail_Grid_Main2();
            target.fromUserRoleDetail(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("uesrrolename","用户角色"); }});
        columnModelList.add(new HashMap(){ { put("userobjectname","用户对象"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<UserRoleDetail> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(UserRoleDetail source:searchResult.getRecords()) {
            UserRoleDetail_Grid_Main2 target=new UserRoleDetail_Grid_Main2();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<UserRoleDetail> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}